#include "grande.h"
#include "extern.h"

//========================================
// ܥ˴
//========================================
void CreateBossEnd(void)
{
  Uint16 sc[] = {1000, 3000};

  Root->Your[BOSS_NO].Chr.Attr    =
  Root->Your[BOSS_NO].Chr.Target  = AttrNone;
  Root->Your[BOSS_NO].Chr.FrameNo = 0;
  Root->Your[BOSS_NO].Chr.Score   = sc[Root->Stage];
  Root->Your[BOSS_NO].Chr.Cnt1    = 2000 / FRAME_RATE;
  Root->Your[BOSS_NO].Hit         = HitNone;
  Root->Your[BOSS_NO].Move        = MoveBossEnd;
}
//========================================
// ܥ˴
//========================================
RcHitEnum MoveBossEnd(CharacterData *my)
{
  Uint8 i;

  if (-- my->Cnt1 == 0) 
    return RcHitBoss;
  if (my->Cnt1 % 3 == 0) {
    KXL_PlaySound(SE_BOMB, KXL_SOUND_PLAY);
    Cchr.Attr     = AttrNone;
    Cchr.Target   = AttrNone;
    Cchr.Spr      = PixBomb1;
    Cchr.FrameNo  = 0;
    Cchr.FrameMax = Cchr.Spr->max;
    Cchr.X        = my->X + RM(my->Spr->data[0].img->Width);
    Cchr.Y        = my->Y + RM(my->Spr->data[0].img->Height);
    CopyYourNew(MoveBomb, HitNone, DrawImageFrame);
    for (i = 0; i < 3; i ++)
      CreateCrash(my->X + RM(my->Spr->data[0].img->Width),
		  my->Y + RM(my->Spr->data[0].img->Height),
		  RM(360));
  }
  return RcHitNone;
}

//========================================
// ܥȯ
//========================================
RcHitEnum HitEnemyToLargeBomb(CharacterData *my, CharacterData *your)
{
  Uint16 i;

  if (my->Y < UP_TOP + 32) return RcHitNone;
  my->Hp -= your->Power;
  if (my->Hp <= 0) {
    for (i = 1; i < MAX_YOUR; i ++) {
      if (Root->Your[i].Chr.Active == False) continue;
      Root->Your[i].Chr.Active = False;
      Root->YourNo --;
    }
    CreateBossEnd();
  } else if (my->Hp % 10 < 2) {
    Cchr.Attr     = AttrNone;
    Cchr.Target   = AttrNone;
    Cchr.Spr      = PixBomb1;
    Cchr.FrameNo  = 0;
    Cchr.FrameMax = Cchr.Spr->max;
    Cchr.X        = my->X + RM(my->Spr->data[0].img->Width);
    Cchr.Y        = my->Y + RM(my->Spr->data[0].img->Height);
    CopyYourNew(MoveBomb, HitNone, DrawImageFrame);
  }
  return RcHitNone;
}

//========================================
// ܥ
//========================================
void CreateBoss(Uint8 *x, Uint8 *y)
{
  RcHitEnum (*mv[])(CharacterData *my) = {
    MoveBoss1, MoveBoss2
  };
  int hp[] = {200, 400};

  Cchr.Attr     = AttrEnemy;
  Cchr.Target   = AttrMy | AttrMShot;
  Cchr.Active   = True;
  Cchr.Hp       = hp[Root->Stage];
  Cchr.Cnt1     =
  Cchr.Cnt2     =
  Cchr.Cnt3     =
  Cchr.Cnt4     =
  Cchr.Cnt5     = 0;
  Cchr.Spr      = PixBoss;
  Cchr.FrameNo  = 0;
  Cchr.FrameMax = Cchr.Spr->max;
  Cchr.X        = Calc(Cchr.Spr->data[Cchr.FrameNo].img, x);
  Cchr.Y        = Calc(Cchr.Spr->data[Cchr.FrameNo].img, y);
  Cchr.AddX     = 0;
  Cchr.AddY     = 1;
  Root->Your[BOSS_NO].Chr  = Cchr;
  Root->Your[BOSS_NO].Draw = DrawImageFrame;
  Root->Your[BOSS_NO].Hit  = HitEnemyToLargeBomb;
  Root->Your[BOSS_NO].Move = mv[Root->Stage];
  if (Root->Stage == 1) {
    Root->Your[BOSS_NO].Chr.Attr = AttrNone | AttrShadow;
    Root->Your[BOSS_NO].Chr.FrameMax /= 2;
    Cchr.Attr     = AttrEnemy;
    Cchr.Target   = AttrMy | AttrMShot | AttrMBomb;
    Cchr.Spr      = PixBossSub;
    Cchr.FrameNo  = 0;
    Cchr.FrameMax = Cchr.Spr->max;
    Cchr.Score    = 300;
    Cchr.Hp       = 200;
    CopyYourNew(MoveBoss2Sub, HitEnemyToBomb, DrawImageFrame);
  }
}

//========================================
// ơ1
//========================================
RcHitEnum MoveBoss1(CharacterData *my)
{
  Uint16 i, d;

  // ޤǰư
  if (my->Y < UP_TOP + 32) {
    my->X += my->AddX;
    my->Y += my->AddY;
    return RcHitNone;
  }
  // 
  if (RM(30) == 0) {
    CreateEnemyShot2(my->X,
		     my->Y + my->Spr->data[0].img->Height - 10,
		     RM(5) ? 0 : GetDirection(my, &(Root->My[MY_NO].Chr)),
		     4);
    CreateEnemyShot2(my->X + my->Spr->data[0].img->Width - PixEShot2->data[0].img->Width,
		     my->Y + my->Spr->data[0].img->Height - 10,
		     RM(5) ? 0 : GetDirection(my, &(Root->My[MY_NO].Chr)),
		     4);
  }
  if (my->Cnt1) my->Cnt1 --;
  if (my->Cnt1 == 0) {
    my->Cnt1 = 64;
    my->Cnt2 = 1;
    my->Cnt3 = 0;
    my->Cnt4 = 0;
  }
  if (my->Cnt2 == 1) {
    if (my->Cnt3 % 4 == 0) {
      d = RM(20) - 10;
      for (i = 0; i < 10; i ++)
	CreateEnemyShot1(my->X + my->Spr->data[0].img->Width / 2 - PixEShot1->data[0].img->Width / 2,
			 my->Y + my->Spr->data[0].img->Height / 2,
			 210 + i * 30 + d , 6);
    }
    if (++ my->Cnt3 == 17) my->Cnt2 = 0;
  }
  return RcHitNone;
}

//========================================
// ơ2
//========================================
RcHitEnum MoveBoss2(CharacterData *my)
{
  Uint16 i;

  my->X += (my->Attr & AttrEnemy) ? my->AddX * 4 : my->AddX;
  my->Y += my->AddY;
  // ޤǰư
  if (my->Y < UP_TOP + 32)
    return RcHitNone;
  if (my->Cnt1 == 0) {
    my->AddX = 1;
    my->Cnt1 = 1;
  } else if (my->Cnt1 == 1) {
    if (my->Cnt2 == 0) {
      if (++ my->AddY >= 3) my->Cnt2 = 1;
    } else {
      if (-- my->AddY <= -3) my->Cnt2 = 0;
    }
    if (my->X >= UP_RIGHT - my->Spr->data[0].img->Width ||
	my->X <= UP_LEFT) my->AddX = - my->AddX;
  }
  // 
  if (my->Attr & AttrEnemy) {
    if (RM(10) == 0) {
      CreateEnemyShot2(my->X,
		       my->Y + 44,
		       RM(2) ? 0 : GetDirection(my, &(Root->My[MY_NO].Chr)),
		       6);
      CreateEnemyShot2(my->X + my->Spr->data[0].img->Width - PixEShot2->data[0].img->Width,
		       my->Y + 44,
		       RM(2) ? 0 : GetDirection(my, &(Root->My[MY_NO].Chr)),
		       6);
    }
    if (my->Cnt3 == 0) {
      if (RM(4) == 0) {
	for (i = 330; i <= 390; i += 10) {
	  CreateEnemyShot1(my->X + 6, my->Y + 44, i, 2 + RM(5));
	  CreateEnemyShot1(my->X + 70, my->Y + 44, i, 2 + RM(5));
	}
      }
      CreateEnemyShot1(my->X + 6, my->Y, 270, 4);
      CreateEnemyShot1(my->X + 70, my->Y, 90, 4);
      my->Cnt3 = 20;
    }
    if (my->Cnt3) my->Cnt3 --;
  }
  return RcHitNone;
}
//========================================
// ơ2
//========================================
RcHitEnum MoveBoss2Sub(CharacterData *my)
{
  my->X = (Root->Your[BOSS_NO].Chr.X + Root->Your[BOSS_NO].Chr.Spr->data[0].img->Width / 2) - my->Spr->data[0].img->Width / 2;
  my->Y = (Root->Your[BOSS_NO].Chr.Y + Root->Your[BOSS_NO].Chr.Spr->data[0].img->Height / 2) - my->Spr->data[0].img->Height / 2;
  // 
  if (my->Cnt1 == 0) {
    my->Cnt2 = 1;
    my->Cnt3 = 0;
    my->Cnt4 = RM(2);
    my->Cnt1 = 50;
  }
  if (my->Cnt1) my->Cnt1 --;
  if (my->Cnt2 == 1) {
    if (my->Cnt4)
      CreateEnemyShot3(my->X - 4 + my->Spr->data[0].img->Width / 2,
		       my->Y - 4 + my->Spr->data[0].img->Height / 2,
		       my->FrameNo * 30, 4);
    my->FrameNo = (++ my->FrameNo) % my->FrameMax;
    if (++ my->Cnt3 == 36) my->Cnt2 = 0;
  }
}
