#include "grande.h"
#define _EXTERN_DEF_
#include "extern.h"

//========================================
// KXL
//========================================
void KXL(void)
{
  static KXL_Image *tmp, *logo;
  static Sint16 y, ay, max;
  static Uint16 w, h;
  static Bool flag = False;
  KXL_Rect rect = {UP_TOP, UP_LEFT, WIDTH, HEIGHT};
  
  KXL_ClearFrame(rect);
  if (Root->Cnt == 0) { // 
    tmp = KXL_LoadBitmap(INST_PATH "/bmp/kxl.bmp", 0);
    w = tmp->Width;
    h = tmp->Height;
    logo = KXL_StrechImage(tmp, w, h);
    y = UP_TOP - logo->Height;
    ay = 0;
    max = 19;
  }
  // ΥХɽ
  if (max) {
    if (flag == False) {
      ay ++;
      if (ay > max) {
	max /= 1.5;
	ay = -max;
	flag = True;
      }
    } else {
      if (ay) ay ++;
      else    flag = False;
    }
    y += ay;
  } else {
    if (Root->Cnt >= 110 && Root->Cnt <= 115) { // 
      if (Root->Cnt == 110)
	KXL_PlaySound(SE_MBOMB, KXL_SOUND_PLAY);
      w *= 1.13;
      h *= 1.13;
      KXL_DeleteImage(logo);
      logo = KXL_StrechImage(tmp, w, h);
    } else if (Root->Cnt == 140) { // λ
      KXL_DeleteImage(tmp);
      KXL_DeleteImage(logo);
      Root->MainFlag = MainOpening;
      return;
    }
  }
  // 
  if (Root->Cnt < 110)
    KXL_PutImage(logo, UP_LEFT + (WIDTH - logo->Width) / 2, y);
  else
    KXL_PutImage(logo, UP_LEFT + (WIDTH - logo->Width) / 2, 
		 UP_TOP + (HEIGHT - logo->Height) / 2);
}

//========================================
// ᥤ롼ס٥ȥå
//========================================
void MainLoop(void)
{
  KXL_Rect rect = {UP_TOP, UP_LEFT, WIDTH, HEIGHT};
  MainEnum bak = -1;

  while (1) {
    // ޳Ԥ
    if (KXL_GetTimer() == False) continue;
    // ޳ߥꥹ
    KXL_ResetTimer();
    // ٥ȥå
    while (KXL_CheckEvents()) {
      switch (KXL_GetEvents()) {
      case KXL_EVENT_KEY_PRESS:
        switch (KXL_GetKey()) {
        case KeyShot:  Root->Key |= KShot;  break;
        case KeySShot: Root->Key |= KSShot; break;
        case KeyLeft:  Root->Key |= KLeft;  break;
        case KeyRight: Root->Key |= KRight; break;
        case KeyUp:    Root->Key |= KUp;    break;
        case KeyDown:  Root->Key |= KDown;  break;
        case KeyPause: Root->Key |= KPause; break;
        case KeyQuit:
	  if (Root->MainFlag == MainKXL) break;
	  if (Root->MainFlag != MainOpening) {
	    UnLoadStageData();
	    Root->MainFlag = MainOpening;
	    Root->Cnt = 0;
	  }
          break;
        default: break;
        }
        break;
      case KXL_EVENT_KEY_RELEASE:
        switch (KXL_GetKey()) {
        case KeyShot:  Root->Key &= KShotMask;  break;
        case KeySShot: Root->Key &= KSShotMask; break;
        case KeyLeft:  Root->Key &= KLeftMask;  break;
        case KeyRight: Root->Key &= KRightMask; break;
        case KeyUp:    Root->Key &= KUpMask;    break;
        case KeyDown:  Root->Key &= KDownMask;  break;
        case KeyPause: Root->Key &= KPauseMask; break;
        default:                                break;
        }
        break;
      }
    }
    bak = Root->MainFlag;
    // ե饰ˤƽ¹Ԥ
    switch (Root->MainFlag) {
    case MainKXL:
      KXL();
      break;
    case MainOpening:
      if (Opening() == True) return;
      break;
    case MainStart:
      Start();
      break;
    case MainGame:
      Game(True);
      // ݡå
      if (Root->Key & KPause) Root->MainFlag = MainPause;
      break;
    case MainPause:
      Game(False);
      // ݡå
      Root->MainFlag = (Root->Key & KShot) ? MainGame : MainPause;
      break;
    case MainClear:
      Game(True);
      ClearAndGameOver();
      break;
    case MainGameOver:
      Game(True);
      ClearAndGameOver();
      break;
    case MainEnding:
      break;
    }
    if (bak != Root->MainFlag) Root->Cnt = 0;
    else                       Root->Cnt ++;
    // ɥ
    KXL_UpDate(rect);
  }
}

//========================================
// ΰ
//========================================
void CreateRoot(void)
{
  // δ
  Root = (RootData *)KXL_Malloc(sizeof(RootData));
  // ʬ饯
  Root->My = (CharacterObject *)KXL_Malloc(sizeof(CharacterObject) * MAX_MY);
  // Ũ饯
  Root->Your = (CharacterObject *)KXL_Malloc(sizeof(CharacterObject) * MAX_YOUR);
  // 󥭥󥰾
  Ranking = (RankingData *)KXL_Malloc(sizeof(RankingData) * 5);
  // ɥ
  KXL_CreateWindow(WIDTH, HEIGHT,
                   PACKAGE VERSION,
                   KXL_EVENT_KEY_PRESS_MASK |
                   KXL_EVENT_KEY_RELEASE_MASK);
  KXL_ReSizeFrame(PIC_WIDTH, PIC_HEIGHT);
  // 
  ReadScore();
  Root->Key = KNone;
  Root->MainFlag = MainKXL;
}

//========================================
// ΰ
//========================================
void DeleteRoot(void)
{
  KXL_DeleteWindow();
  KXL_Free(Root->My);
  KXL_Free(Root->Your);
  KXL_Free(Root);
  KXL_Free(Ranking);
}

//========================================
// ץ
//========================================
void options(int argc, char **argv)
{
  Uint16 i;

  fprintf(stderr, "url   : http://www2.mwnet.or.jp/~fc3srx7\n");
  fprintf(stderr, "email : fc3srx7@mwnet.or.jp\n\n");
  for (i = 1; i < argc; i ++) {
    if (!strcmp(argv[i], "-h") || !strcmp(argv[i], "--help")) {
      fprintf(stderr, "\nUsage: grande [--display display] [--version] [--help]\n");
      fprintf(stderr, "--display display : Use display as the target display\n");
      fprintf(stderr, "--version         : Show version number and exit\n");
      fprintf(stderr, "--help            : Show this message\n");
      exit(1);
    }
  }
  fprintf(stderr, "\"grande --help\" for command line parameters\n");
  for (i = 1; i < argc; i ++) {
    if (!strcmp(argv[i], "--display")) {
      fprintf(stderr, "Using display: %s\n", argv[i + 1]);
      KXL_DisplayName(argv[i + 1]);
    }
    if (!strcmp(argv[i], "--version")) {
      fprintf(stderr, "Version is " VERSION "\n");
      exit(1);
    }
  }
}

//========================================
// ᥤ
//========================================
int main(int argc, char **argv)
{
  Uint8 *sname[] = {
    "pow",
    "bomb",
    "shot",
    "go",
    "mbomb",
    ""
  };

  // ץ
  options(argc, argv);
  // 
  srand(time(NULL));
  // ΰ
  CreateRoot();
  // ᡼
  CreateImage();
  // ɽ
  KXL_InitSound(INST_PATH "/wav", sname);
  // ޳
  KXL_Timer(FRAME_RATE);
  // ᥤ롼
  MainLoop();
  // ɽλ
  KXL_EndSound();
  // ᡼
  DeleteImage();
  // ΰ
  DeleteRoot();
  return 0;
}
